this.name = "NShields_player";

"use strict";

this.startUpComplete = function _NShields_player_startUpComplete() {
    //Give player same colours etc. as standard NPCs
    player.ship.script.NShields_flashers = worldScripts.NShields.$getShieldColours(player.ship);
    player.ship.script.NShields_exploder = worldScripts.NShields.$getShieldExploder(player.ship);
    
    if (player.ship.scriptInfo) {
        // slightly more complicated than for NPCs because other OXPs may have adjusted shields already:
        if (player.ship.scriptInfo.max_shield_forward) player.ship.maxForwardShield += (parseInt(ship.scriptInfo.max_shield_forward) - 128);
        if (player.ship.scriptInfo.max_shield_aft) player.ship.maxAftShield += (parseInt(ship.scriptInfo.max_shield_aft) - 128);
        if (player.ship.scriptInfo.shield_recharge_forward) player.ship.forwardShieldRechargeRate += (parseFloat(ship.scriptInfo.shield_recharge_forward) - 2);
        if (player.ship.scriptInfo.shield_recharge_aft) player.ship.aftShieldRechargeRate += (parseFloat(ship.scriptInfo.shield_recharge_aft) - 2);
    }
}

this.shipTakingDamage = function _NShields_player_shipTakingDamage(amount, whom, type) {
    var that = _NShields_player_shipTakingDamage;
    var ws = (that.ws = that.ws || worldScripts.NShields);
    var pship = player.ship;

    if (type == "heat damage" || type == "hit a planet" || type == "hit a sun" || type == "removed" || type == "cascade weapon") return;
    var hitLocation = ws.$locateHit(pship, whom);
    var hitLocationRelative = hitLocation.subtract(pship.position);
    if (hitLocationRelative.dot(pship.vectorForward) > 0)
        ws.$drawShieldFX(hitLocation, pship.forwardShield, player.ship, whom)
    else
        ws.$drawShieldFX(hitLocation, pship.aftShield, player.ship, whom)
    
    if (amount) ws.$drawSparks(hitLocation, pship, amount);
}
